// Blikajici Hvezda - Dimmer
// (c) Pavel Kaspar, 2022
// kaspar@pk.cz
// version 0.9; 8.1.2022

/* ATTiny connections
 Leg  Function
 1    PB5, Reset, Output         // Pro pouziti Reset Pinu je nutne zmenit Fuses. Nepujde ale ISP programovani
 2    PB3, Output
 3    PB4, Output 
 4    GND
 5    PB0 - Output
 6    PB1 - Output
 7    PB2 - Output
 8    +5V
*/

unsigned long startMillis;
unsigned long currentMillis;
const unsigned long period = 75;

void Nastav(byte Hodnota, int Cekej) {
  Hodnota = Hodnota & 0x3F;      // 00xx xxxx  
  PORTB = Hodnota; 
  delay(Cekej);
}

void Jas(int j) {                // Jas "j" po dobu "period"
  if (j > 100) j=100;
  startMillis = millis();
  do {
    PORTB = B00000000;
    delayMicroseconds(201-j-j); 
    currentMillis = millis();   
    PORTB = B00111111;
    delayMicroseconds(j+j);
    PORTB = B00000000;
  }
  while (currentMillis - startMillis <= period);
}

// Inicializace
void setup() {
  pinMode(0, OUTPUT);
  pinMode(1, OUTPUT);
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);             
  PORTB = B00000000;
}

// Main
void loop() { 
  for (unsigned int i=0; i<=19; i++) {  // Postupne rozsveceni
    Jas(i);
  }
  for (unsigned int i=20; i<=50; i=i+2) {  
    Jas(i);
  }
  
  Jas(54);
  Jas(58);
  Jas(62);
  Jas(67);
  Jas(73);
  Jas(79);
  Jas(86);
  Jas(93);
  Jas(100);
  Jas(93);
  Jas(86);
  Jas(79);
  Jas(73);
  Jas(67);
  Jas(62);
  Jas(58);
  Jas(54);

  for (unsigned int i=50; i>=20; i=i-2) { 
    Jas(i);
  }  
  for (unsigned int i=19; i>0; i--) {  
    Jas(i);
  }
//  Nastav(0, period);   // Uplne zhasni - Lepe to vypada bez uplneho zhasnuti
}


